package example;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import otpc.*;
public class AuthedServlet extends HttpServlet {
  protected void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
    if (authed(req) == null)
      throw new ServletException("not authenticated");
    if ("logout".equals(req.getParameter("action")))
      logout(req, res);
    else if ("changetotp".equals(req.getParameter("action")))
        changeTotp(req, res);
    else
      renderAuthedPage(req, res);
  }
  String authed(HttpServletRequest request) {
    return (String) request.getSession(false).getAttribute("authed");
  }
  void logout(HttpServletRequest req, HttpServletResponse res) throws IOException, ServletException {
    req.getSession(false).setAttribute("authed", null);
    res.sendRedirect("login.jsp");
  }
  void changeTotp(HttpServletRequest req, HttpServletResponse res) throws IOException {
    res.sendRedirect(
        OtpC2.prov(
            req.getSession(true),
            authed(req),
            new OtpBoolHandler() {
              public void handle(HttpServletRequest req, HttpServletResponse res,
                  String u, Boolean nil) throws IOException {
                res.sendRedirect("example/AuthedServlet");
              }}));
  }
  void renderAuthedPage(HttpServletRequest req, HttpServletResponse res)
      throws IOException {
    res.setContentType("text/html");
    ServletOutputStream out = res.getOutputStream();
    out.write(("you are logged in as: " + authed(req) + "<br/>").getBytes());
    out.write("<a href=\"?action=changetotp\">change totp</a><br/>".getBytes());
    out.write("<a href=\"?action=logout\">logout</a><br/>".getBytes());
  }
}
