package otpc;

import java.io.*;
import java.util.*;
import java.util.concurrent.atomic.*;
import javax.servlet.http.*;

import otpc.impl.*;

public class OtpC2 {
  public static String key;
  private static AtomicInteger counter = new AtomicInteger(); //JSON resp parsed as int not long. AI wraps ok.
  private static String REQS = "totp:outstanding-reqs";

  public static String prov(HttpSession s, String u, OtpBoolHandler h)
                          throws IOException {
    return call(s, "prov", u, new OtpBoolAdaptor(h));
  }
  public static String auth(HttpSession s, String u, OtpBoolHandler h)
                          throws IOException {
    return call(s, "auth", u, new OtpBoolAdaptor(h));
  }
  private static String call(HttpSession s, String fn, String u,
      OtpHandler h) throws IOException {
    Integer reqid = Integer.valueOf(counter.incrementAndGet());
    Object[] or = new Object[]{reqid, u, h};
    pushOutstandingRequest(s, or);
    return OtpC.makeClientMsg(key, new Object[]{reqid,fn,u});
  }
  private static List<Object[]> pushOutstandingRequest(HttpSession s, Object[] or) {
    List<Object[]> x = (List<Object[]>) s.getAttribute(REQS);
    if (x == null) {
      x = new LinkedList<Object[]>();
      s.setAttribute(REQS, x);
    }
    x.add(0, or);
    return x;
  }
  static Object[] removeOutstandingRequest(HttpSession s, Object reqid) {
    List<Object[]> ors = (List<Object[]>) s.getAttribute(REQS);
    for(Iterator<Object[]> it = ors.iterator(); it.hasNext();) {
      Object[] x = it.next();
      if (x[0].equals(reqid)) {
        it.remove();
        return x;
      }
    }
    return null;
  }
}
