package otpc.impl;

import java.io.*;
import java.net.*;
import java.util.*;

import org.json.*;

public class OtpC {
  
  //// Protocol Service Client ////
  
  //later: temporarily blacklist failed servers
  
  static List<String> urls = Arrays.asList(new String[] {
      "https://a.totp.me:8443/prot",
      "https://b1.totp.me:18443/prot2",
      "https://b2.totp.me:28443/prot2",
      "https://b3.totp.me:38443/prot2",
      "https://b4.totp.me:48443/prot2"
      });

  public static String makeClientMsg(String key, Object[] call) throws IOException {
    return fetch(urls.iterator(), "make-client-msg", key, encode(call));
  }
  public static Object[] decodeServerMsg(String key, String msg, String sid) throws IOException {
    int sid2 = sid == null ? 0 : Integer.parseInt(sid);
    return decodeJSONArray(fetch(urls.subList(sid2, sid2+1).iterator(), "decode-server-msg", key, msg));
  }
  
  static String fetch(Iterator<String> urls, String action, String key, String arg)
      throws IOException {
    if (!urls.hasNext())
      throw new IOException("could not connect to any servers");
    try { return slurp(new URL(urls.next()+"?action="+action+"&key="+key+"&arg="+arg).openStream()); } 
    catch (IOException e) { return fetch(urls, action, key, arg); }
  }
  private static String encode(Object[] call)
                               throws UnsupportedEncodingException, JSONException {
    return URLEncoder.encode(JSONObject.valueToString(call), "UTF-8");
  }
  private static String slurp(InputStream in) throws IOException {
    StringBuilder result = new StringBuilder();
    int c;
    while ((c = in.read()) != -1) result.append((char) c);
    return result.toString();
  }
  private static Object[] decodeJSONArray(String s) {
    JSONArray a = new JSONArray(s);
    Object[] ans = new Object[a.length()];
    for(int i = 0; i < ans.length; ++i) ans[i] = a.get(i);
    return ans;
  }
  
  //// Otp Client ////
  
  ////
  
  //you need a better JSON parser, one that can parse a JSON tree into a Java one
  
  public static boolean isTrue(Object x) {
    if (JSONArray.class.isInstance(x)) {
      JSONArray x1 = (JSONArray) x;
      if (x1.length() == 0) return false;
    }
    return true;
  }

}
